<?php 
/**
* $Id: mod_eshop_pweek.php 131 2011-03-19 12:35:58Z stratakisS $
* @version: 1.0
* @package: Component IOS Eshop
* @subpackage: Module Product of Week
* @author: Stavros Stratakis (WebGift Web Services)
* @email: info@webgift.gr
* @link: http://www.webgift.gr
* @license: Commercial
* @copyright: (C) 2007-2010 Stavros Stratakis (WebGift Web Services). All rights reserved.
* @description: Component IOS Eshop is a full shopping cart solution for Elxis CMS.
*************************************************************************************/

defined('_VALID_MOS') or die('Direct Access to this location is not allowed.');


if (!class_exists('eshopperiod')) {
	class eshopperiod {
	   
	    private $eshop = null;
        private $errormsg ='';      
        private $multititle = 1;
        private $viewtype = 0;
        private $orderby = 0;       
		private $categories = '';
		private $prodtypes = '';
		private $manufacturers = '';   
		private $titletag = 2;        
		private $showbrief = 0;
		private $showsku = 0;
		private $showmanuf = 1;
		private $showctg = 1;
		private $_Itemid = 0;        
                          
		/*********************/
		/* MAGIC CONSTRUCTOR */
		/*********************/
		public function __construct($params, $eshop) {
			$this->eshop = $eshop;
            $this->getConfig($params);
		}
        
        
		/*************************/
		/* GET MODULE PARAMETERS */
		/*************************/        
        private function getConfig($params){
            global $mainframe,$my;
            
            $eshopdir =  $mainframe->getCfg('absolute_path').'/administrator/components/com_eshop';  
            if (!file_exists($eshopdir.'/config.eshop.php')) {
                $this->errormsg = 'IOS Eshop Component not found!';
            }else{
                require_once($eshopdir.'/config.eshop.php');
                $cfg = new eshopConfig();
                if ($cfg->get('SHOPSTATUS') != 1) {
                   $this->errormsg = 'IOS Eshop Component must be in Online Mode in order to run Eshop Tags Module Successfully!';
                }
            }
            if ($this->eshop->cfg->get('SHOPSTATUS') == 0) { return; }
			if (($this->eshop->cfg->get('SHOPSTATUS') == -1) && ($my->gid != 25)) { return; } 
               
            $this->multititle = (int)$params->get('multititle', 1);
            $this->viewtype = (int)$params->get('viewtype', 0);  
            $this->orderby = (int)$params->get('orderby', 0);            
			$this->categories = trim($params->get('categories', ''));
			$this->prodtypes = trim($params->get('prodtypes', ''));
			$this->manufacturers = trim($params->get('manufacturers', ''));
			$this->titletag = (int)$params->get('titletag', 2);
			$this->showbrief = (int)$params->get('showbrief', 0);
			$this->showsku = (int)$params->get('showsku', 0);
			$this->showmanuf = (int)$params->get('showmanuf', 1);
			$this->showctg = (int)$params->get('showctg', 0);                                    
        }
        
        
        /*****************/
		/* ERROR MESSAGE */
		/*****************/
		private function errorScreen() {
			echo '<div style="margin: 2px; padding: 3px; border: 1px solid #DD0000; color: #000000; font-weight: normal; background-color: #FFF;">'."\n";
			echo '<span style="font-weight:bold; color: #CC0000;">'._ELX_ERROR."</span><br />\n";
			echo ($this->errormsg != '') ? $this->errormsg : 'Unknown error';
			echo "</div>\n";
		}                       


		/*********************************/
		/* GET PRODUCT FROM THE DATABASE */
		/*********************************/
        private function getProduct(){
            global $database, $eshop;
            
            $wheres = array();
            if($this->viewtype == 0){
               $per = 7;
            }elseif($this->viewtype == 1){
               $per = 14;
            }elseif($this->viewtype == 2){
               $per = 30;
            }elseif($this->viewtype == 3){
               $per = 90;
            }elseif($this->viewtype == 4){
               $per = 180;
            }elseif($this->viewtype == 5){
               $per = 365;
            }            
            
            $prevWeek = time() - ($per * 24 * 60 * 60);
            $now = date('Y-m-d H:i:s');
            $prev = date('Y-m-d H:i:s', $prevWeek);  
            $wheres[] = "p.dateadded >= '".$prev."' AND p.dateadded <= '". $now ."' ";
			$orderby = 'p.hits DESC';

			if ($this->categories != '') { $wheres[] = "c.cid IN (".$this->categories.")"; }
			if ($this->prodtypes != '') { $wheres[] = "p.ptid IN (".$this->prodtypes.")"; }
			if ($this->manufacturers != '') { $wheres[] = "p.mid IN (".$this->manufacturers.")"; }

			$andwhere = '';
			if (count($wheres) > 0) {
				$andwhere = 'AND ('.implode(') AND (', $wheres).')';
			}

			$query = "SELECT p.id, p.cid, p.sku, p.title, p.dialect1, p.dialect2, p.dialect3, p.in_stock, p.immaterial,"
			."\n p.briefdesc, p.dialbrief1, p.dialbrief2, p.dialbrief3, p.dateadded, p.specialoffer,"
			."\n p.mid, p.offerexpire, c.title AS ctitle, c.dialect1 AS cdialect1, c.dialect2 AS cdialect2,"
			."\n c.dialect3 AS cdialect3, c.seotitle, m.manufacturer, t.manuftitle, r.price, r.discount, r.tax, i.file AS image"
			."\n FROM #__eshop_products p"
			."\n LEFT JOIN #__eshop_categories c ON c.cid=p.cid"
			."\n LEFT JOIN #__eshop_manufacturers m ON m.mid=p.mid"
			."\n LEFT JOIN #__eshop_product_types t ON t.ptid=p.ptid"
			."\n LEFT JOIN #__eshop_prices r ON r.id=p.id"
			."\n LEFT JOIN #__eshop_images i ON i.id=p.id"
			."\n WHERE p.published='1' AND c.published='1' AND r.sgid='1'"
			."\n ".$andwhere
			."\n GROUP BY p.id ORDER BY ".$orderby;
			$database->setQuery($query, '#__',1, 0);
			$rows = $database->loadRowList();

			unset($query, $wheres, $andwhere, $orderby);

			$result = array();
			if ($rows) {
				$group_prices = array();
				if (($this->eshop->shoppergroup > 1) && ($this->eshop->cfg->get('SHOPSTATUS') <> -3)) {
					$product_ids = array();
					foreach ($rows as $row) { $product_ids[] = $row['id']; }	
					$database->setQuery("SELECT id, price, discount, tax FROM #__eshop_prices WHERE id IN (".implode(',',$product_ids).") AND sgid='".$this->eshop->shoppergroup."'");
					$special_prices = $database->loadRowList();
					if ($special_prices) {
						foreach ($special_prices as $special_price) {
							$prid = $special_price['id'];
							$group_prices[$prid] = array(
								'price' => $special_price['price'],
								'discount' => $special_price['discount'],
								'tax' => $special_price['tax'],
							);
						}
					}
					unset($special_prices, $product_ids);
				}

				foreach ($rows as $row) {
					$product = new stdClass();
					$product->id = (int)$row['id'];
					$product->cid = (int)$row['cid']; 
					$product->sku = $row['sku']; 
					$product->dtitle = $this->eshop->getDialected($row); 
					$product->in_stock = (int)$row['in_stock'];
					$product->immaterial = (int)$row['immaterial'];
					$product->dateadded = $row['dateadded'];
					$product->specialoffer = $row['specialoffer'];
					$product->mid = (int)$row['mid'];
					$product->offerexpire = $row['offerexpire'];
					$product->category = $this->eshop->getDialected($row, 'title', 'c');
					$product->brief = $this->eshop->getDialected($row, 'briefdesc');
					$product->seotitle = $row['seotitle'];
					$product->manufacturer = $row['manufacturer'];
					$product->manuftitle = (int)$row['manuftitle'];
					$product->price = $row['price'];
					$product->discount = $row['discount'];
					$product->tax = $row['tax'];
					$product->image = trim($row['image']);

					$prid = $row['id'];
					if (isset($group_prices[$prid])) {
						$product->price = $group_prices[$prid]['price'];
						$product->discount = $group_prices[$prid]['discount'];
						$product->tax = $group_prices[$prid]['tax'];
					}

					$result[] = $product;
					unset($product);
				}
			}
			unset($rows);
			
			return $result;            
        }


		/************************/
		/* GET COMPONENT ITEMID */
		/************************/
		private function getitemid() {
			global $mainframe, $Itemid, $lang, $database, $my, $option;

			if ($option == 'com_eshop') {
				$this->_Itemid = $Itemid;
			} else {
				$access = !$mainframe->getCfg('shownoauth');
				$query = "SELECT id FROM #__menu WHERE link='index.php?option=com_eshop' AND published='1'"
				."\n AND ((language IS NULL) OR (language LIKE '%".$lang."%'))"
				.($access ? "\n AND access IN (".$my->allowed.")" : '');
				$database->setQuery($query, '#__', 1, 0);
				$_Itemid = intval($database->loadResult());
				$this->_Itemid = ($_Itemid) ? $_Itemid : $Itemid;
			}
		}
        
        
		/**********************/
		/* LOAD IOS ESHOP CSS */
		/**********************/
		private function loadCSS() {
			if (defined('ESHOP_CSS_LOADED')) { return; }
			if ((_GEM_RTL == 1) && file_exists($this->eshop->path.'/template/'.$this->eshop->cfg->get('TEMPLATE').'/'.$this->eshop->cfg->get('TEMPLATE').'-rtl.css')) {
				$cssfile = $this->eshop->sslurl.'/template/'.$this->eshop->cfg->get('TEMPLATE').'/'.$this->eshop->cfg->get('TEMPLATE').'-rtl.css';
			} else {
				$cssfile = $this->eshop->sslurl.'/template/'.$this->eshop->cfg->get('TEMPLATE').'/'.$this->eshop->cfg->get('TEMPLATE').'.css';
			}
			define('ESHOP_CSS_LOADED', 1);
?>
			<script type="text/javascript">
			/* <![CDATA[ */
			var header = document.getElementsByTagName("head")[0];
			var csslink = document.createElement("link");
			csslink.setAttribute("rel", "stylesheet");
			csslink.setAttribute("type", "text/css");
			csslink.setAttribute("href", "<?php echo $cssfile; ?>");
			csslink.setAttribute("media", "all");
			header.appendChild(csslink);
			/* ]]> */
			</script>
<?php 
		}
        
        
		/*************************/
		/*PREPARE EXECUTE MODULE */
		/*************************/  
        private function prepareExecute(){
            
            $this->getitemid();
			$product = $this->getProduct();
			$this->loadCSS();

			if ($this->multititle) {	            
            switch($this->viewtype){
                case 0:
                $ttl = 'Product of Week';
                break;
                case 1:
                $ttl = 'Product of 2 Weeks';
                break;
                case 2:
                $ttl = 'Product of Month';
                break;
                case 3:
                $ttl = 'Product of 3 Months';
                break;
                case 4:
                $ttl = 'Product of 6 Months';
                break;
                case 5:
                $ttl = 'Product of Year';
                break;
            }
				switch ($this->titletag) {
					case 1: echo '<h1 class="eshop_h1">'.$ttl."</h1>\n"; break;
					case 2: echo '<h2 class="eshop_h2">'.$ttl."</h2>\n"; break;
					case 3: echo '<h3 class="eshop_h3">'.$ttl."</h3>\n"; break;
					case 0: default: echo '<h3>'.$ttl."</h3>\n"; break;
				}
			}

			$this->htmlResult($product);            
        }
        
        
		/*****************/
		/* LIST PRODUCTS */
		/*****************/
		private function htmlResult($product=null) {
			global $mainframe,$lang;

			if (!$product) {
				echo '<div class="eshop_general_block">No products found matching given criteria!</div>'."\n";
				return;
			}

			$dir = _GEM_RTL ? ' dir="rtl"' : '';
			$tw = $this->eshop->cfg->get('THUMB_WIDTH');
            
			for ($i=0; $i<count($product); $i++) {
				$row = $product[$i];

				$link = sefRelToAbs('index.php?option=com_eshop&task=view&id='.$row->id.'&Itemid='.$this->_Itemid, IOSESHOPBASE.'/'.$row->seotitle.'/'.$row->id.'.html');
				$mlink = sefRelToAbs('index.php?option=com_eshop&task=manufacturer&mid='.$row->mid.'&Itemid='.$this->_Itemid, IOSESHOPBASE.'/manufacturers/'.$row->mid.'.html');
				$clink = sefRelToAbs('index.php?option=com_eshop&task=category&cid='.$row->cid.'&Itemid='.$this->_Itemid, IOSESHOPBASE.'/'.$row->seotitle.'/');

				if ((trim($row->image) != '') && file_exists($this->eshop->path.'/product_thumbnails/'.$row->image)) {
					$sz = getimagesize($this->eshop->path.'/product_thumbnails/'.$row->image);
					$th = intval(($tw * $sz[1])/$sz[0]);
					$img = $this->eshop->sslurl.'/product_thumbnails/'.$row->image;
				} else {
					$img = $this->eshop->sslurl.'/images/no-photo.jpg';
					$th = $tw;
				}

				$outofstock = 0;
				if ($this->eshop->cfg->get('STOCK_ENABLED')) {
					if (($row->immaterial == '1') && $this->eshop->cfg->get('STOCK_IMMATERIAL') && ($row->in_stock == 0)) {
						$outofstock = 1;
					}
					if (($row->immaterial == '0') && ($row->in_stock == 0)) {
						$outofstock = 1;
					}
				}

					echo '<table cellspacing="0" cellpadding="0" border="0" width="100%" >'."\n";
					echo '<tr >'."\n";
					echo '<td class="eshop_cleantd" align="center" colspan="2" valign="top" width="'.($this->eshop->cfg->get('THUMB_WIDTH') ).'">';
					echo '<a href="'.$link.'" title="'.$row->dtitle.'"><img src="'.$img.'" border="0" alt="'.$row->dtitle.'" width="'.$tw.'" height="'.$th.'" class="bordered" /></a>'._LEND;
					if ($this->eshop->isNew($row->dateadded)) {
						echo '<div class="eshop_new_product">'.$this->eshop->lng->NEWPRODUCT."</div>\n";
					}
					echo "</td></tr><tr>\n";
					echo '<td align="center">'."\n";
					echo '<a href="'.$link.'" title="'.$row->dtitle.'" class="eshop_biglink"'.$dir.'>'.$row->dtitle."</a><br />\n";
					if ($this->showsku && (trim($row->sku) != '')) {
						echo '<span class="eshop_sku"><strong>'.$this->eshop->lng->SKU.': </strong>'.$row->sku."</span><br />\n";
					}
					if ($this->showbrief && ($row->brief != '')) {
						echo $row->brief."<br />\n";
					}
					if ($this->showmanuf) {
						echo '<strong style="font-size:11px;">'.$this->eshop->manufidtotitle($row->manuftitle).':</strong> <a href="'.$mlink.'" title="'.sprintf($this->eshop->lng->ALLPRODSBY, $row->manufacturer).'" class="eshop_link"'.$dir.'>'.$row->manufacturer."</a><br />\n";
					}
					if ($this->showctg) {
						echo '<strong style="font-size:11px;">'._E_CATEGORY.':</strong> <a href="'.$clink.'" title="'.$row->category.'" class="eshop_link">'.$row->category."</a><br />\n";
					}
					if ($row->specialoffer) {
						$timeremaining = $this->eshop->timeremaining($row->offerexpire);
						if ($timeremaining != '') {
							echo '<div class="eshopexpirebox">'.$timeremaining."</div>\n";
						}
					}

					if ($row->specialoffer) { echo '<div class="eshop_special_offer">'.$this->eshop->lng->SPECIAL_OFFER."</div>\n"; }
					if ($this->eshop->cfg->get('SHOPSTATUS') <> -3) {
						if ($row->discount > 0) {
							$normalprice = $this->eshop->calculatePrice($row->price, 0, $row->tax);
							echo '<div class="eshop_normalprice"'.$dir.'>'.$this->eshop->shortprice($normalprice)."</div>\n";
						}
						$price = $this->eshop->calculatePrice($row->price, $row->discount, $row->tax);
						echo '<div class="eshop_price"'.$dir.'>'.$this->eshop->addIdCurrency($row->id, $price).'</div>';
						if ($row->discount > 0) {
							echo '<div class="eshop_discount"'.$dir.'>'.$this->eshop->lng->DISCOUNT.' '.sprintf("%01.2f", $row->discount)."%</div><br />\n";
						}
					}
					if ($outofstock) {
						echo '<div class="eshop_outstock">'.$this->eshop->lng->OUTOFSTOCK2."</div>\n";
					} else {
						$cartLink = $mainframe->getCfg('live_site').'/index2.php?option=com_eshop&amp;task=addtocart&amp;id='.$row->id.'&amp;Itemid='.$this->_Itemid.'&amp;mylang='.$lang;
						echo '<div class="btn_addcart"><span class="btn_left">&nbsp;</span><a href="'.$cartLink.'" title="'.$this->eshop->lng->ADDTOCART.'">'.$this->eshop->lng->ADDTOCARTSHORT.'</a><span class="btn_right">&nbsp;</span></div>';
					}
					echo "</td>\n</tr>\n";
					echo "</table>\n";
			}
		}
        
                        
		/*************************/
		/* RUN MY SWEETY.!RUN... */
		/************************/            
        public function run(){
            if ($this->errormsg != '') {
                $this->errorScreen();
                return;
			}            
           $this->prepareExecute();
        }
    }
}


global $mainframe;
if (file_exists($mainframe->getCfg('absolute_path').'/administrator/components/com_eshop/includes/eshop.class.php')) {
	if (isset($GLOBALS['eshop']) && is_object($GLOBALS['eshop']) && ($GLOBALS['eshop'] instanceof katastima)) {
		$eshop = $GLOBALS['eshop'];
	} else {
		require_once($mainframe->getCfg('absolute_path').'/administrator/components/com_eshop/includes/eshop.class.php');
		$eshop = new katastima();
		$GLOBALS['eshop'] = $eshop;
	}

	$pofweek = new eshopperiod($params, $eshop);
	$pofweek->run();
	unset($pofweek);
}

?>